# frozen_string_literal: true

require 'gitlab'
require 'json'
require 'net/http'
require 'set'
require 'time'
require 'yaml'

BALANCING_PROMETHEUS_QUERY = File.read('balancing_query.promql')
CIREPOM_BOT_PROJECT_NAME = 'gitlab-com/gl-infra/infra-bots/cirepom-bot'
TARGET_INSTANCE = ENV['TARGET_INSTANCE']

def log(msg)
  puts "[FEEDER] #{msg}"
end

def check_required_envvars
  %w[
    THANOS_HOST
    TARGET_INSTANCE
    TARGET_API_PRIVATE_TOKEN
    OPS_API_PRIVATE_TOKEN
  ].each do |envvar|
    raise "Missing envvar #{envvar}" unless ENV.key?(envvar)
  end
end

def set_gitlab_to_target_instance
  Gitlab.endpoint = "https://#{TARGET_INSTANCE}/api/v4"
  Gitlab.private_token = ENV['TARGET_API_PRIVATE_TOKEN']
end

def environment_prometheus_identifier
  case TARGET_INSTANCE
  when 'gitlab.com' then 'gprd'
  when 'staging.gitlab.com' then 'gstg'
  else raise("Couldn't identify a prometheus environment for #{TARGET_INSTANCE}")
  end
end

def shards_ordered_by_balancing_requirement
  query = BALANCING_PROMETHEUS_QUERY.gsub('<env>', environment_prometheus_identifier)

  uri = URI("http://#{ENV['THANOS_HOST']}/api/v1/query")
  params = {
    query: query,
    time: Time.now.to_f
  }
  uri.query = URI.encode_www_form(params)

  log('Querying Thanos for balancing metrics')
  response = Net::HTTP.get_response(uri)
  raise 'Failed querying Thanos for balancing metrics' unless response.is_a?(Net::HTTPSuccess)

  thanos_response = JSON.parse(response.body)
  raise 'Thanos returned a status that is not success' unless thanos_response['status'] == 'success'

  thanos_response['data']['result'].map do |item|
    [
      item['metric']['fqdn'].gsub(/-stor-g.*$/, ''),
      item['value'][1]
    ]
  end
end

def convert_shard_name_per_app_convention(shard_name)
  if shard_name.include?('praefect')
    shard_name.gsub(/.*(\d+)$/, 'praefect-file\1')
  else
    "nfs-#{shard_name.gsub(/-(\d+)$/, '\1')}"
  end
end

def determine_source_and_dest_shards
  all_shards = shards_ordered_by_balancing_requirement
  log("Available shards are #{all_shards.map(&:first).join(', ')}")

  excluded_shards = Set.new(ENV['EXCLUDED_SHARDS'].to_s.split(','))

  log("Excluding shards #{excluded_shards.to_a.join(',')} ...")
  available_shards = all_shards.reject { |shard| excluded_shards.include?(shard[0]) }

  source_shard = convert_shard_name_per_app_convention(available_shards.first[0])
  dest_shard = convert_shard_name_per_app_convention(available_shards.last[0])
  log("Source shard = #{source_shard}, destination shard = #{dest_shard}")

  [
    source_shard,
    dest_shard
  ]
end

def fetch_largest_projects(source_shard)
  log("Fetching largest repositories of shard #{source_shard}")

  Gitlab.projects(
    repository_storage: source_shard,
    last_activity_before: (Time.now.utc - 2 * 7 * 24 * 60 * 60).iso8601,
    order_by: 'repository_size',
    sort: 'desc',
    statistics: true
  )
end

def create_change_request_issue(projects, source_shard, dest_shard)
  log('Creatign a change request issue ...')

  preamble = <<~DESC
    _Generated by [CI job ##{ENV['CI_JOB_ID']}](#{ENV['CI_JOB_URL']})_

    The following projects/repositories are candidates for rebalancing from **#{source_shard}** to **#{dest_shard}**:

    | Name | Size | Last Activity At |
    | ---- | ---- | ---------------- |
  DESC

  table = projects.map do |project|
    size_gb = format('%<size>.2fGB', size: project.statistics.repository_size.fdiv(1024 * 1024 * 1024))
    "| [#{project.name}](#{project.web_url}) | #{size_gb} | #{project.last_activity_at} |"
  end.join("\n")

  postscript = "\n\nTo execute this batch, run the `execute` job in this [pipeline](#{ENV['CI_PIPELINE_URL']})."

  description = preamble + table + postscript

  log("Issue will have the following description:\n#{description}")

  return if ENV['DRY_RUN']

  issue = Gitlab.create_issue(
    'gitlab-com/gl-infra/production',
    "Repositories rebalance on #{source_shard}",
    description: description,
    confidential: true
  )
  log("Issue can be found at #{issue.web_url}")

  issue
end

def prepare_gitlab_ci_yaml(reposet_fqrn, reposet_ci_url)
  gitlab_ci = Gitlab.file_contents(CIREPOM_BOT_PROJECT_NAME, '.gitlab-ci.yml', 'master')
  gitlab_ci = YAML.load(gitlab_ci) # rubocop: disable Security/YAMLLoad

  gitlab_ci['variables']['CIREPOM_REPOSET_FQDN'] = TARGET_INSTANCE
  gitlab_ci['variables']['CIREPOM_REPOSET_FQRN'] = reposet_fqrn
  gitlab_ci['variables']['CIREPOM_REPOSET_CRI_URL'] = reposet_ci_url

  YAML.dump(gitlab_ci)
end

# rubocop: disable Metrics/AbcSize, Metrics/MethodLength
def feed_projects_to_cirepom(projects, source_shard, dest_shard, cr_issue)
  csv_str = CSV.generate do |csv|
    projects.each do |project|
      csv << [project.id, project.path, source_shard, dest_shard]
    end
  end

  cr_issue_stanza = "production##{cr_issue.iid}"
  source_branch = cr_issue_stanza
  target_branch = "#{TARGET_INSTANCE}/#{cr_issue_stanza}"

  log("Creating branch #{source_branch} in #{CIREPOM_BOT_PROJECT_NAME}")
  Gitlab.create_branch(CIREPOM_BOT_PROJECT_NAME, source_branch, 'master')
  log("Creating branch #{target_branch} in #{CIREPOM_BOT_PROJECT_NAME}")
  Gitlab.create_branch(CIREPOM_BOT_PROJECT_NAME, target_branch, 'master')

  log("Creating load.csv in #{source_branch} with the content:\n#{csv_str}")
  Gitlab.create_file(
    CIREPOM_BOT_PROJECT_NAME,
    "runtime/var/data/cirepom/#{TARGET_INSTANCE}/#{cr_issue_stanza}/load.csv",
    source_branch,
    csv_str,
    "Add projects to rebalance per #{cr_issue_stanza}"
  )

  toml_str = <<~TOML
    iid = #{cr_issue.iid}
    labels = "Service::Gitaly,infra-bot::cirepom,infra-process::RepositoryMigration"
    project_id = #{cr_issue.project_id}
    reposet = "#{cr_issue_stanza}"
    url = "#{cr_issue.web_url}"
  TOML

  log("Creating cri.toml in #{source_branch} with the content:\n#{toml_str}")
  Gitlab.create_file(
    CIREPOM_BOT_PROJECT_NAME,
    "runtime/var/data/cirepom/#{TARGET_INSTANCE}/#{cr_issue_stanza}/cri.toml",
    source_branch,
    toml_str,
    "Add cri.toml to rebalance for #{cr_issue_stanza}"
  )

  log("Updating .gitlab-ci.yml in #{source_branch}")
  Gitlab.edit_file(
    CIREPOM_BOT_PROJECT_NAME,
    '.gitlab-ci.yml',
    source_branch,
    prepare_gitlab_ci_yaml("#{TARGET_INSTANCE}/#{cr_issue_stanza}", cr_issue.web_url),
    "Update .gitlab-ci.yml for #{cr_issue_stanza}"
  )

  log("Creating a merge request from #{source_branch} to #{target_branch}...")
  merge_request = Gitlab.create_merge_request(
    CIREPOM_BOT_PROJECT_NAME,
    "Ready to load: #{TARGET_INSTANCE}/#{cr_issue_stanza}",
    description: "Per #{cr_issue.web_url}",
    source_branch: source_branch,
    target_branch: target_branch
  )
  log("Merge request can be found at #{merge_request.web_url}")

  pipeline = nil
  5.times do |i|
    log("Waiting for merge request pipeline to be created, attempt ##{i + 1}")
    sleep(30)
    pipeline = Gitlab.pipelines(CIREPOM_BOT_PROJECT_NAME, sha: merge_request.sha).first

    break if pipeline
  end
  raise 'Failed fetching the MR pipeline' if pipeline.nil?

  log("Pipeline found. ID = #{pipeline.id}")

  load_job = Gitlab.pipeline_jobs(CIREPOM_BOT_PROJECT_NAME, pipeline.id).first
  log('Starting the load job...')
  Gitlab.job_play(CIREPOM_BOT_PROJECT_NAME, load_job.id)

  5.times do |i|
    log("Waiting for the load job to be finish, attempt ##{i + 1}")
    sleep(30)
    job = Gitlab.job(CIREPOM_BOT_PROJECT_NAME, load_job.id)

    next if job.finished_at.nil?
    break if job.status == 'success'

    raise 'Load job failed'
  end

  log('Accepting the merge request...')
  Gitlab.accept_merge_request(CIREPOM_BOT_PROJECT_NAME, merge_request.iid)

  log('Creating a pipeline for migrating...')
  migrate_pipeline = Gitlab.create_pipeline(CIREPOM_BOT_PROJECT_NAME, target_branch, { 'ACTION' => 'migrate' })
  log("Pipeline can be found at #{migrate_pipeline.web_url}")
end
# rubocop: enable Metrics/AbcSize, Metrics/MethodLength

def in_ops
  old_endpoint = Gitlab.endpoint
  old_private_token = Gitlab.private_token

  Gitlab.endpoint = 'https://ops.gitlab.net/api/v4'
  Gitlab.private_token = ENV['OPS_API_PRIVATE_TOKEN']

  log("Switching to #{Gitlab.endpoint} ...")
  yield
  log("Switching back to #{old_endpoint}")

  Gitlab.endpoint = old_endpoint
  Gitlab.private_token = old_private_token
end

check_required_envvars
set_gitlab_to_target_instance

if ARGV.count.positive?
  source_shard, dest_shard, projects, cr_issue = Marshal.load(ARGF.read) # rubocop: disable Security/MarshalLoad
else
  source_shard, dest_shard = determine_source_and_dest_shards
  projects = fetch_largest_projects(source_shard)
  cr_issue = create_change_request_issue(projects, source_shard, dest_shard)
end

if ENV['DRY_RUN']
  log('Exiting as DRY_RUN is set.')
  exit
end

if ENV['CI_JOB_NAME'] == 'prepare'
  dump_path = File.join(Dir.pwd, 'data.dump')
  projects.client = nil # We don't want to leak the private token
  File.write(dump_path, Marshal.dump([source_shard, dest_shard, projects, cr_issue]))

  log("Marshal file is written to #{dump_path}")
  exit
end

in_ops { feed_projects_to_cirepom(projects, source_shard, dest_shard, cr_issue) }
